/*
 * Caelum sun
 */
#include "CaelumSun.h"

#include "CaelumManager.h"

using namespace Ogre;

CaelumSun::CaelumSun (CaelumManager *parent) {
	mParent = parent;

	mColour = ColourValue::White;
	mLight = mParent->mSceneMgr->createLight ("CaelumSun");
  mLight->setType (Light::LT_DIRECTIONAL);
  mLight->setDiffuseColour (mColour);
  mPosition = Vector3 (1, 1, 0);

  mShowFlares = false;
  mFlaresOverlay = static_cast<Overlay *>(OverlayManager::getSingleton ().getByName ("Caelum/Flares"));
//  mFlaresOverlay->getChild ("Caelum/FlaresGlow")->getMaterial ()->getTechnique (0)->getPass (0)->setDiffuse (0.5, 0.4, 0.2);
  mFlaresOverlay->getChild ("Caelum/FlaresGlow")->setColour (ColourValue (0.5, 0.4, 0.2));
}
//------------------------------------------------------------------
void CaelumSun::_update (void) {
  _calculatePosition ();
  mLight->setDirection (-mPosition);
  mLight->setDiffuseColour (mColour);

  // Updating flares
  if (mShowFlares) {
    mFlaresOverlay->show ();
  }
  else {
    mFlaresOverlay->hide ();
  }
}
//------------------------------------------------------------------
void CaelumSun::_calculatePosition (void) {
  Real omega = ((mParent->mTime / 86400) - 0.25) * 2 * Math::PI;
  mPosition = Vector3 (Math::Cos (omega), Math::Sin (omega), 0);
}