/*
 * Caelum Dome
 * Author: Kencho
 * Starting date: 04-15-2004
 * Last update: 04-15-2004
 */
#ifndef __CAELUMDOME_H__
#define __CAELUMDOME_H__

#include "Ogre.h"

#include "CaelumDynaColour.h"

namespace Ogre {
	/* Sky dome */
	class CaelumDome : public CaelumDynaColour {
		public:
      // Constructor
      CaelumDome (SceneManager *sceneMgr, SceneNode *parent);
      // Destructor
      ~CaelumDome ();
      // Get the dome node
      SceneNode *getSceneNode (void);
      // Set pressure
      void setPressure (Real pressure);
      // Get pressure
      Real getPressure (void);
      // Update
      void update (Real time, Vector3 camPos, Real range);
		protected:
      // Scene node associated with this dome
      SceneNode *mDomeNode;
      // Material of the dome node
      Material *mMaterial;
      // Atmosphere pressure
      Real mPressure;
	};
}

#endif