/*
 * Caelum Dynacolour
 * Author: Kencho
 * Starting date: 04-15-2004
 * Last update: 04-15-2004
 */
#ifndef __CAELUMDYNACOLOUR_H__
#define __CAELUMDYNACOLOUR_H__

#include "Ogre.h"

namespace Ogre {
	/* A coloured (dynamically managed optional) caelum element */
	class CaelumDynaColour {
		public:
      // Constructor
      CaelumDynaColour (void);
      // Destructor
      ~CaelumDynaColour (void);
      // Set colour
      void setColour (ColourValue colour);
      // Get colour
      ColourValue getColour (void);
      // Set colour map image
      void setColourMap (Image *image);
      // Get colour map image
      Image *getColourMap (void);
      // Update colour
      void updateColour (Real time);
      // Set colour modifier
      void setColourModifier (ColourValue colour);
      // Get colour modifier
      ColourValue getColourModifier (void);
      // Set colour saturation modifier
      void setSaturationModifier (Real saturation);
      // Get colour saturation modifier
      Real getSaturationModifier (void);
      // Get final processed colour
      ColourValue getFinalColour (void);
		protected:
      // Current colour
      ColourValue mColour;
      // Colours map
      Image *mColourMap;
      // Colours map data
      unsigned char *mColourMapData;
      // Colours map data steps
      unsigned int mColourMapSteps;
      // Colours map components (24-32 bit)
      unsigned char mColourMapComponents;
      // Colour modifier (i.e. A reddish modifier...)
      ColourValue mColourModifier;
      // Saturation modifier (i.e: A stormy day modifies sky colour saturation to grey...)
      Real mSaturationModifier;
	};
}

#endif