/*
 * Caelum Haze
 * Author: Kencho
 * Starting date: 04-15-2004
 * Last update: 04-15-2004
 */
#ifndef __CAELUMHAZE_H__
#define __CAELUMHAZE_H__

#include "Ogre.h"

#include "CaelumDynaColour.h"

namespace Ogre {
	/* Manages haze */
	class CaelumHaze : public CaelumDynaColour {
		public:
      // Constructor
      CaelumHaze ();
      // Destructor
      ~CaelumHaze ();
      // Set turbidity
      void setTurbidity (Real turbidity);
      // Get turbidity
      Real getTurbidity (void);
      // Set turbidity limits
      void setTurbidityRange (Real min, Real max);
      // Get min turbidity
      Real getMinTurbidity (void);
      // Get max turbidity
      Real getMaxTurbidity (void);
      // Update
      void update (Real time, SceneManager *sceneMgr, Real unitScale);
		protected:
      // Air turbidity
      Real mTurbidity;
      // Minimum turbidity
      Real mMinTurbidity;
      // Maximum turbidity
      Real mMaxTurbidity;
	};
}

#endif