/*
 * Caelum Object
 * Author: Kencho
 * Starting date: 04-15-2004
 * Last update: 04-16-2004
 */
#ifndef __CAELUMOBJECT_H__
#define __CAELUMOBJECT_H__

#include "Ogre.h"

#include "CaelumDynaColour.h"

namespace Ogre {
	/* Manages a single celestial object (i.e: Sun, moon....) */
	class CaelumObject : public CaelumDynaColour {
		public:
      // Constructor
      CaelumObject (String name, SceneNode *parent);
      // Destructor
      ~CaelumObject (void);
      // Set the associated scene node
      void setSceneNode (SceneNode *node);
      // Get the associated scene node
      SceneNode *getSceneNode (void);
      // Set the time offset
      void setTimeOffset (Real offset);
      // Get the time offset
      Real getTimeOffset (void);
      // Update
      void update (Real time, Vector3 camPos, Vector3 scale);
		protected:
      // Scene node associated with this object
      SceneNode *mSceneNode;
      // Light coming from this object
      Light *mLight;
      // Time this object needs to rotate around us
      Real mPeriod;
      // Time offset (we don't want all the objects moving at the same time...)
      Real mTimeOffset;
	};
}

#endif