/*
 * Caelum Haze
 * Author: Kencho
 * Starting date: 04-15-2004
 * Last update: 04-15-2004
 */
#include "CaelumHaze.h"

namespace Ogre {
  //-------------------------------------------------------------------------------------
  CaelumHaze::CaelumHaze (void) {
    // Init attributes
    mMinTurbidity = 0.0005;
    mMaxTurbidity = 0.001;
    mTurbidity = mMinTurbidity;

    CaelumDynaColour::CaelumDynaColour ();
  }
  //-------------------------------------------------------------------------------------
  CaelumHaze::~CaelumHaze (void) {
  }
  //-------------------------------------------------------------------------------------
  void CaelumHaze::setTurbidity (Real turbidity) {
    if (turbidity < mMinTurbidity)
      turbidity = mMinTurbidity;
    if (turbidity > mMaxTurbidity)
      turbidity = mMaxTurbidity;

    mTurbidity = turbidity;
  }
  //-------------------------------------------------------------------------------------
  Real CaelumHaze::getTurbidity (void) {
    return mTurbidity;
  }
  //-------------------------------------------------------------------------------------
  void CaelumHaze::setTurbidityRange (Real min, Real max) {
    if (min <= max) {
      mMinTurbidity = min;
      mMaxTurbidity = max;
    }
    else {
      // Swapped
      mMinTurbidity = max;
      mMaxTurbidity = min;
    }
  }
  //-------------------------------------------------------------------------------------
  Real CaelumHaze::getMinTurbidity (void) {
    return mMinTurbidity;
  }
  //-------------------------------------------------------------------------------------
  Real CaelumHaze::getMaxTurbidity (void) {
    return mMaxTurbidity;
  }
  //-------------------------------------------------------------------------------------
  void CaelumHaze::update (Real time, SceneManager *sceneMgr, Real unitScale) {
    ColourValue c;

    // Update colour
    updateColour (time);

    // Get processed colour
    c = getFinalColour ();

    // Update turbidity
    mTurbidity = mMinTurbidity + (mMaxTurbidity - mMinTurbidity) * c.a;

    // Update fog
    sceneMgr->setFog (FOG_LINEAR, c, 0, 0, unitScale / mTurbidity);
  }
  //-------------------------------------------------------------------------------------
}